/*--------------------------------------------------------------------*/
/* Displays particles ... most of the OpenGL graphics calls are       */
/* in this routine.                                                   */
/*--------------------------------------------------------------------*/
void display(void) {
   int    i;

   if( Ltrace ) fprintf(stderr,"display: In routine\n");
   glMatrixMode(GL_MODELVIEW);

   glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

   glPushMatrix();
   glTranslatef( 0.0, 0.0, -0.5 * (ProjectionBbox[4] + ProjectionBbox[5]));
   if( Ltrace ) {
      fprintf(stderr,"display: Rotation angles: %g %g %g\n",Xrot,Yrot,Zrot);
   }
   glRotated( Xrot, 1.0, 0.0, 0.0 );
   glRotated( Yrot, 0.0, 1.0, 0.0 );
   glRotated( Zrot, 0.0, 0.0, 1.0 );

   glScaled( Zoom, Zoom, Zoom );

   if( Np ) {

      for( i = 0; i < Np; i++ ) {
         int ic = i % Ncol;
         if( Ltrace ) {
            fprintf(stderr,"display: Particle %d  Size %g  Pos (%g,%g,%g)\n", 
                    i+1,BaseSize*Size[i],Coords[3*i],Coords[3*i+1],Coords[3*i+2]);
         }
         glColor3d(R[1],G[1],B[1]);
         glPointSize((GLfloat) clamped(BaseSize * Size[i],MinSize,MaxSize));
         glBegin(GL_POINTS);
            glVertex3d(Coords[3*i],Coords[3*i+1],Coords[3*i+2]);
         glEnd();
      } 
   }
   if( DrawOrigin ) {
      glColor3d(R[0],G[0],B[0]);
      glPointSize((GLfloat) (BaseSize * 1));
      glBegin(GL_POINTS);
         glVertex3d(0.0,0.0,0.0);
      glEnd();
   }
   glFlush();
   if( Dbuff) glutSwapBuffers();
   glPopMatrix();
}
P
